<!DOCTYPE html>
<html lang="en">

<head>
    <meta charset="UTF-8">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <title>Task 30.10 - HTML Form</title>
    <link rel="stylesheet" href="https://cdn.jsdelivr.net/npm/bootstrap@4.0.0/dist/css/bootstrap.min.css"
        integrity="sha384-Gn5384xqQ1aoWXA+058RXPxPg6fy4IWvTNh0E263XmFcJlSAwiGgFAW/dAiS6JXm" crossorigin="anonymous">
    <script src="https://code.jquery.com/jquery-3.2.1.slim.min.js"
        integrity="sha384-KJ3o2DKtIkvYIK3UENzmM7KCkRr/rE9/Qpg6aAZGJwFDMVNA/GpGFF93hXpG5KkN"
        crossorigin="anonymous"></script>
    <script src="https://cdn.jsdelivr.net/npm/popper.js@1.12.9/dist/umd/popper.min.js"
        integrity="sha384-ApNbgh9B+Y1QKtv3Rn7W3mgPxhU9K/ScQsAP7hUibX39j7fakFPskvXusvfa0b4Q"
        crossorigin="anonymous"></script>
    <script src="https://cdn.jsdelivr.net/npm/bootstrap@4.0.0/dist/js/bootstrap.min.js"
        integrity="sha384-JZR6Spejh4U02d8jOt6vLEHfe/JQGiRRSQQxSfFWpi1MquVdAyjUar5+76PVCmYl"
        crossorigin="anonymous"></script>
</head>

<body>
    <div class="container">
        <div class="row">
            <div class="col-md-4">
                <form id="loginform">
                    <div class="form-group">
                        <label for="input-email">Email address</label>
                        <input type="email" class="form-control" id="input-email" aria-describedby="emailHelp"
                            placeholder="Enter email">
                        <small id="emailHelp" class="form-text text-muted">We'll never share your email with anyone
                            else.</small>
                    </div>
                    <div class="form-group">
                        <label for="input-password">Password</label>
                        <input type="password" class="form-control" id="input-password" placeholder="Password">
                    </div>
                    <button type="submit" class="btn btn-primary">Submit</button>
                </form>
            </div>
        </div>

    </div>
</body>
<script>
    'use strict';
    /*** REGION 1 - Global variables - Vùng khai báo biến, hằng số, tham số TOÀN CỤC */
    const gREQUEST_STATUS_OK = 200;
    const gREQUEST_STATUS_CREATED = 201;
    const gREQUEST_READY_STATUS_FINISH_AND_OK = 4;
    const gBASE_URL = "https://62458c222cfed18817229118.mockapi.io/users";
    const gBASE_URL_CONTACTS = "https://62458c222cfed18817229118.mockapi.io/contacts";

    var loginForm = document.getElementById("loginform");

    /*** REGION 2 - Vùng gán / thực thi sự kiện cho các elements */

    loginForm.addEventListener("submit", (e) => {
        // Sử dụng preventDefault để loại bỏ hành động submit mặc định của form
        e.preventDefault();
        console.log("Bạn đang ở hàm xử lý sự kiện submit của thẻ form");
        // Tiếp theo thực hiện 4 bước để gọi api login
        xulyLogin();
    });

    /*** REGION 3 - Event handlers - Vùng khai báo các hàm xử lý sự kiện */
    // Hàm gọi API Login
    function xulyLogin() {
        /*Chia 4 bước: Đọc, kiểm tra dữ liệu, nếu dữ liệu hợp lệ thì gọi API và xử lý kết quả trả về*/
        // B1: Đọc dữ liệu
        var vUserObject = readFormData();
        console.log(vUserObject);
        //B2: Kiểm tra dữ liệu
        var vValidateData = validateData(vUserObject);
        if (vValidateData == true) {
            // B3: Nếu dữ liệu ok => Gọi API 
            console.log("Dữ liệu OK, chuẩn bị gọi API");
            var vXmlHttpLogin = new XMLHttpRequest();
            goiAPI(vXmlHttpLogin, vUserObject);          
            vXmlHttpLogin.onreadystatechange = function () {
                if (this.readyState == gREQUEST_READY_STATUS_FINISH_AND_OK && this.status == gREQUEST_STATUS_OK) {
                    // B4: Xử lý kết quả trả về
                    xuLyHienThi(vXmlHttpLogin);
                }
            }
        }
    }

    /*** REGION 4 - Common funtions - Vùng khai báo hàm dùng chung trong toàn bộ chương trình*/
    // Đọc dữ liệu từ form
    function readFormData() {
        var vInputEmailElement = document.getElementById("input-email");
        var vInputPasswordElement = document.getElementById("input-password");
        var vUserObject = {
            email: vInputEmailElement.value,
            password: vInputPasswordElement.value
        }
        return vUserObject;
    }

    // Kiểm tra dữ liệu
    function validateData(paramUserObject) {
        // Kiểm tra email có đúng hay không
        if (validateEmail(paramUserObject.email) == false) {
            alert("Email không hợp lệ");
            return false;
        }
        // Kiểm tra mật khẩu: có tối thiểu 6 ký tự
        if (paramUserObject.password.length < 6) {
            alert("Mật khẩu phải có ít nhất 6 ký tự");
            return false;
        }
        return true;
    }

    // Hàm xác thực địa chỉ email (lấy từ google, không phải là hàm chuẩn, chỉ lấy làm ví dụ minh họa)
    function validateEmail(email) {
        var re = /\S+@\S+\.\S+/;
        return re.test(email);
    }
    function goiAPI(paramXmlHttpLogin, paramUserObject){
        console.log ("Bắt đầu gọi API");
        const vParams = new URLSearchParams(paramUserObject);
        console.log ("Chuỗi query string (url search params): " + vParams.toString());
        var vUrl =  gBASE_URL + "?" + vParams.toString();
        console.log ("Địa chỉ URL của API: " + vUrl);
        paramXmlHttpLogin.open("GET", vUrl, true);
        paramXmlHttpLogin.send();
    }
    // Hàm xử lý kết quả trả về từ API và hiển thị
    function xuLyHienThi(paramXmlHttpLogin){
        var vLoginInfo = paramXmlHttpLogin.responseText;
        console.log ("Chuỗi dữ liệu nhận được: ");
        console.log(vLoginInfo);
        if (vLoginInfo.length > 0){
            alert ("Login thành công");
        } else {
            alert ("Login thất bại!");
        }                 
    }
</script>

</html>